diff --git a/CMakeLists.txt b/CMakeLists.txt
index 02aad23544..1a211817e6 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -55,10 +55,6 @@ SET(LIB_SOURCE_FILES
     lib/token.c
     lib/util.c)
 
-IF (APPLE)
-    SET_SOURCE_FILES_PROPERTIES(lib/socket.c PROPERTIES COMPILE_FLAGS -Wno-deprecated-declarations)
-ENDIF (APPLE)
-
 ADD_LIBRARY(libh2o STATIC ${LIB_SOURCE_FILES})
 SET_TARGET_PROPERTIES(libh2o PROPERTIES OUTPUT_NAME h2o)
 SET_TARGET_PROPERTIES(libh2o PROPERTIES EXCLUDE_FROM_ALL 1)
@@ -75,3 +71,7 @@ TARGET_LINK_LIBRARIES(examples-websocket libh2o ${OPENSSL_LIBRARIES} ${LIBUV_LIB
 ADD_EXECUTABLE(h2o ${LIB_SOURCE_FILES} src/main.c)
 SET_TARGET_PROPERTIES(h2o PROPERTIES COMPILE_FLAGS "-DH2O_USE_LIBUV=0")
 TARGET_LINK_LIBRARIES(h2o ${OPENSSL_LIBRARIES} ${LIBYAML_LIBRARIES} pthread)
+
+IF (APPLE)
+    SET_SOURCE_FILES_PROPERTIES(lib/socket.c src/main.c PROPERTIES COMPILE_FLAGS -Wno-deprecated-declarations)
+ENDIF (APPLE)
diff --git a/examples/simple.c b/examples/simple.c
index f4710e2cf1..efd6c24edd 100644
--- a/examples/simple.c
+++ b/examples/simple.c
@@ -92,7 +92,7 @@ static int post_test(h2o_handler_t *self, h2o_req_t *req)
 
 static h2o_global_configuration_t config;
 static h2o_context_t ctx;
-static h2o_ssl_context_t *ssl_ctx;
+static SSL_CTX *ssl_ctx;
 
 #if H2O_USE_LIBUV
 
@@ -187,6 +187,36 @@ static int create_listener(void)
 
 #endif
 
+static int setup_ssl(const char *cert_file, const char *key_file)
+{
+    SSL_load_error_strings();
+    SSL_library_init();
+    OpenSSL_add_all_algorithms();
+
+    ssl_ctx = SSL_CTX_new(SSLv23_server_method());
+    SSL_CTX_set_options(ssl_ctx, SSL_OP_NO_SSLv2);
+
+    /* load certificate and private key */
+    if (SSL_CTX_use_certificate_file(ssl_ctx, cert_file, SSL_FILETYPE_PEM) != 1) {
+        fprintf(stderr, "an error occured while trying to load server certificate file:%s\n", cert_file);
+        return -1;
+    }
+    if (SSL_CTX_use_PrivateKey_file(ssl_ctx, key_file, SSL_FILETYPE_PEM) != 1) {
+        fprintf(stderr, "an error occured while trying to load private key file:%s\n", key_file);
+        return -1;
+    }
+
+    /* setup protocol negotiation methods */
+#if H2O_USE_NPN
+    h2o_ssl_register_npn_protocols(ssl_ctx, h2o_http2_npn_protocols);
+#endif
+#if H2O_USE_ALPN
+    h2o_ssl_register_alpn_protocols(ssl_ctx, h2o_http2_alpn_protocols);
+#endif
+
+    return 0;
+}
+
 int main(int argc, char **argv)
 {
     signal(SIGPIPE, SIG_IGN);
@@ -209,8 +239,7 @@ int main(int argc, char **argv)
 
     /* disabled by default: uncomment the block below to use HTTPS instead of HTTP */
     /*
-    ssl_ctx = h2o_ssl_new_server_context("server.crt", "server.key", h2o_http2_tls_identifiers);
-    if (ssl_ctx == NULL)
+    if (setup_ssl("server.crt", "server.key") != 0)
         goto Error;
     */
 
diff --git a/examples/websocket.c b/examples/websocket.c
index 013b243176..c939dc5e7b 100644
--- a/examples/websocket.c
+++ b/examples/websocket.c
@@ -60,7 +60,7 @@ static int on_req(h2o_handler_t *self, h2o_req_t *req)
 
 static h2o_global_configuration_t config;
 static h2o_context_t ctx;
-static h2o_ssl_context_t *ssl_ctx;
+static SSL_CTX *ssl_ctx;
 
 static void on_connect(uv_stream_t *server, int status)
 {
@@ -84,6 +84,36 @@ static void on_connect(uv_stream_t *server, int status)
         h2o_http1_accept(&ctx, sock);
 }
 
+static int setup_ssl(const char *cert_file, const char *key_file)
+{
+    SSL_load_error_strings();
+    SSL_library_init();
+    OpenSSL_add_all_algorithms();
+
+    ssl_ctx = SSL_CTX_new(SSLv23_server_method());
+    SSL_CTX_set_options(ssl_ctx, SSL_OP_NO_SSLv2);
+
+    /* load certificate and private key */
+    if (SSL_CTX_use_certificate_file(ssl_ctx, cert_file, SSL_FILETYPE_PEM) != 1) {
+        fprintf(stderr, "an error occured while trying to load server certificate file:%s\n", cert_file);
+        return -1;
+    }
+    if (SSL_CTX_use_PrivateKey_file(ssl_ctx, key_file, SSL_FILETYPE_PEM) != 1) {
+        fprintf(stderr, "an error occured while trying to load private key file:%s\n", key_file);
+        return -1;
+    }
+
+    /* setup protocol negotiation methods */
+#if H2O_USE_NPN
+    h2o_ssl_register_npn_protocols(ssl_ctx, h2o_http2_npn_protocols);
+#endif
+#if H2O_USE_ALPN
+    h2o_ssl_register_alpn_protocols(ssl_ctx, h2o_http2_alpn_protocols);
+#endif
+
+    return 0;
+}
+
 int main(int argc, char **argv)
 {
     uv_loop_t *loop = uv_default_loop();
@@ -111,7 +141,12 @@ int main(int argc, char **argv)
     ws_handler.on_req = on_req;
     h2o_linklist_insert(&config.default_host.handlers, &ws_handler._link);
     h2o_context_init(&ctx, loop, &config);
-    //ssl_ctx = h2o_ssl_new_server_context("server.crt", "server.key", NULL);
+
+    /* disabled by default: uncomment the block below to use HTTPS instead of HTTP */
+    /*
+    if (setup_ssl("server.crt", "server.key") != 0)
+        goto Error;
+    */
 
     return uv_run(loop, UV_RUN_DEFAULT);
 
diff --git a/h2o.xcodeproj/project.pbxproj b/h2o.xcodeproj/project.pbxproj
index 91ff68b4d0..d60bdd36d5 100644
--- a/h2o.xcodeproj/project.pbxproj
+++ b/h2o.xcodeproj/project.pbxproj
@@ -41,8 +41,8 @@
 		107923D319A3217300C52AD6 /* util.c in Sources */ = {isa = PBXBuildFile; fileRef = 107923C019A3217300C52AD6 /* util.c */; };
 		1079240119A3241A00C52AD6 /* libh2o.a in Frameworks */ = {isa = PBXBuildFile; fileRef = 1079231519A320A700C52AD6 /* libh2o.a */; };
 		1079240819A3247A00C52AD6 /* libh2o.a in Frameworks */ = {isa = PBXBuildFile; fileRef = 1079231519A320A700C52AD6 /* libh2o.a */; };
-		1079241619A324B400C52AD6 /* websocket.c in Sources */ = {isa = PBXBuildFile; fileRef = 1079241319A324B400C52AD6 /* websocket.c */; };
-		1079242919A325BE00C52AD6 /* simple.c in Sources */ = {isa = PBXBuildFile; fileRef = 107923FC19A3238500C52AD6 /* simple.c */; };
+		1079241619A324B400C52AD6 /* websocket.c in Sources */ = {isa = PBXBuildFile; fileRef = 1079241319A324B400C52AD6 /* websocket.c */; settings = {COMPILER_FLAGS = "-Wno-deprecated-declarations"; }; };
+		1079242919A325BE00C52AD6 /* simple.c in Sources */ = {isa = PBXBuildFile; fileRef = 107923FC19A3238500C52AD6 /* simple.c */; settings = {COMPILER_FLAGS = "-Wno-deprecated-declarations"; }; };
 		1079243019A3260E00C52AD6 /* libh2o.a in Frameworks */ = {isa = PBXBuildFile; fileRef = 1079231519A320A700C52AD6 /* libh2o.a */; };
 		1079244119A3264300C52AD6 /* picohttpparser.c in Sources */ = {isa = PBXBuildFile; fileRef = 1079235A19A3210D00C52AD6 /* picohttpparser.c */; };
 		1079244419A3265C00C52AD6 /* chunked.c in Sources */ = {isa = PBXBuildFile; fileRef = 107923AE19A3217300C52AD6 /* chunked.c */; };
@@ -62,7 +62,7 @@
 		1079245419A32C0800C52AD6 /* token_table.h in Headers */ = {isa = PBXBuildFile; fileRef = 1079245319A32C0800C52AD6 /* token_table.h */; };
 		10BA72AA19AAD6300059392A /* stream.c in Sources */ = {isa = PBXBuildFile; fileRef = 10BA72A919AAD6300059392A /* stream.c */; };
 		10F417CC19C1907B00B6E31A /* libh2o.a in Frameworks */ = {isa = PBXBuildFile; fileRef = 1079231519A320A700C52AD6 /* libh2o.a */; };
-		10F417D619C190F800B6E31A /* main.c in Sources */ = {isa = PBXBuildFile; fileRef = 10F417D519C190F800B6E31A /* main.c */; };
+		10F417D619C190F800B6E31A /* main.c in Sources */ = {isa = PBXBuildFile; fileRef = 10F417D519C190F800B6E31A /* main.c */; settings = {COMPILER_FLAGS = "-Wno-deprecated-declarations"; }; };
 		10F417FF19C2D2F800B6E31A /* picotest.c in Sources */ = {isa = PBXBuildFile; fileRef = 10F417FD19C2D2F800B6E31A /* picotest.c */; };
 		10F4180119C2D31600B6E31A /* yoml.h in Headers */ = {isa = PBXBuildFile; fileRef = 10F4180019C2D31600B6E31A /* yoml.h */; };
 		10F4180519CA75C500B6E31A /* config.c in Sources */ = {isa = PBXBuildFile; fileRef = 10F4180419CA75C500B6E31A /* config.c */; };
diff --git a/include/h2o.h b/include/h2o.h
index 1494392b3e..bcec62ea90 100644
--- a/include/h2o.h
+++ b/include/h2o.h
@@ -43,6 +43,7 @@ extern "C" {
 #include <sys/socket.h>
 #include <time.h>
 #include <unistd.h>
+#include <openssl/ssl.h>
 #include "picohttpparser.h"
 #include "yoml.h"
 
@@ -57,6 +58,17 @@ extern "C" {
 # define H2O_MAX_TOKENS 10240
 #endif
 
+#if OPENSSL_VERSION_NUMBER >= 0x10002000L
+# define H2O_USE_ALPN 1
+# define H2O_USE_NPN 1
+#elif OPENSSL_VERSION_NUMBER >= 0x10001000L
+# define H2O_USE_ALPN 0
+# define H2O_USE_NPN 1
+#else
+# define H2O_USE_ALPN 0
+# define H2O_USE_NPN 0
+#endif
+
 #define H2O_TO__STR(n) #n
 #define H2O_TO_STR(n) H2O_TO__STR(n)
 
@@ -75,7 +87,6 @@ typedef struct st_h2o_conn_t h2o_conn_t;
 typedef struct st_h2o_context_t h2o_context_t;
 typedef struct st_h2o_req_t h2o_req_t;
 typedef struct st_h2o_socket_t h2o_socket_t;
-typedef struct st_h2o_ssl_context_t h2o_ssl_context_t;
 typedef struct st_h2o_timeout_entry_t h2o_timeout_entry_t;
 typedef struct st_h2o_ostream_t h2o_ostream_t;
 
@@ -698,19 +709,20 @@ static int h2o_socket_is_reading(h2o_socket_t *sock);
  * @param ssl_ctx SSL context
  * @param handshake_cb callback to be called when handshake is complete
  */
-void h2o_socket_ssl_server_handshake(h2o_socket_t *sock, h2o_ssl_context_t *ssl_ctx, h2o_socket_cb handshake_cb);
+void h2o_socket_ssl_server_handshake(h2o_socket_t *sock, SSL_CTX *ssl_ctx, h2o_socket_cb handshake_cb);
 /**
  * returns the name of the protocol selected using either NPN or ALPN (ALPN has the precedence).
  * @param sock the socket
  */
 h2o_buf_t h2o_socket_ssl_get_selected_protocol(h2o_socket_t *sock);
 /**
- * construct an SSL context
- * @param cert_file the certificate file (in PEM format)
- * @param key_file the private key file (in PEM format)
- * @param protocols a NULL-terminated list of protocols used for negotiation using ALPN/NPN
+ * registers the protocol list to be used for ALPN
+ */
+void h2o_ssl_register_alpn_protocols(SSL_CTX *ctx, const h2o_buf_t *protocols);
+/**
+ * registers the protocol list to be used for NPN
  */
-h2o_ssl_context_t *h2o_ssl_new_server_context(const char *cert_file, const char *key_file, const h2o_buf_t *protocols);
+void h2o_ssl_register_npn_protocols(SSL_CTX *ctx, const char *protocols);
 
 void h2o_socket__write_pending(h2o_socket_t *sock);
 void h2o_socket__write_on_complete(h2o_socket_t *sock, int status);
@@ -857,7 +869,7 @@ h2o_buf_t h2o_normalize_path(h2o_mempool_t *pool, const char *path, size_t len);
 /**
  * accepts a SSL connection
  */
-void h2o_accept_ssl(h2o_context_t *ctx, h2o_socket_t *sock, h2o_ssl_context_t *ssl_ctx);
+void h2o_accept_ssl(h2o_context_t *ctx, h2o_socket_t *sock, SSL_CTX *ssl_ctx);
 
 int h2o__lcstris_core(const char *target, const char *test, size_t test_len);
 
diff --git a/include/h2o/http2.h b/include/h2o/http2.h
index 7f92504e37..194c2a3fb0 100644
--- a/include/h2o/http2.h
+++ b/include/h2o/http2.h
@@ -28,7 +28,8 @@
 typedef struct st_h2o_http2_conn_t h2o_http2_conn_t;
 typedef struct st_h2o_http2_stream_t h2o_http2_stream_t;
 
-extern const h2o_buf_t *h2o_http2_tls_identifiers;
+extern const char *h2o_http2_npn_protocols;
+extern const h2o_buf_t *h2o_http2_alpn_protocols;
 
 /* defined as negated form of the error codes defined in HTTP2-spec section 7 */
 #define H2O_HTTP2_ERROR_NONE 0
diff --git a/lib/http2/connection.c b/lib/http2/connection.c
index 373668b0ef..9c9e093abb 100644
--- a/lib/http2/connection.c
+++ b/lib/http2/connection.c
@@ -28,12 +28,13 @@
 
 static const h2o_buf_t CONNECTION_PREFACE = { H2O_STRLIT("PRI * HTTP/2.0\r\n\r\nSM\r\n\r\n") };
 
-static const h2o_buf_t tls_identifiers[] = {
-    { H2O_STRLIT("h2-14") },
+#define H2_PROTOCOL_IDENTIFIER "h2-14"
+const char *h2o_http2_npn_protocols = "\x05" H2_PROTOCOL_IDENTIFIER;
+static const h2o_buf_t alpn_protocols[] = {
+    { H2O_STRLIT(H2_PROTOCOL_IDENTIFIER) },
     { NULL, 0 }
 };
-
-const h2o_buf_t *h2o_http2_tls_identifiers = tls_identifiers;
+const h2o_buf_t *h2o_http2_alpn_protocols = alpn_protocols;
 
 const h2o_http2_settings_t H2O_HTTP2_SETTINGS_HOST = {
     /* header_table_size = */ 4096,
diff --git a/lib/socket.c b/lib/socket.c
index 654cac772e..0bce950f0e 100644
--- a/lib/socket.c
+++ b/lib/socket.c
@@ -26,7 +26,6 @@
 #include <fcntl.h>
 #include <limits.h>
 #include <string.h>
-#include <openssl/ssl.h>
 #include "h2o.h"
 
 #if defined(__APPLE__) && defined(__clang__)
@@ -303,7 +302,7 @@ static void proceed_handshake(h2o_socket_t *sock, int status)
     on_handshake_complete(sock, status);
 }
 
-void h2o_socket_ssl_server_handshake(h2o_socket_t *sock, h2o_ssl_context_t *ssl_ctx, h2o_socket_cb handshake_cb)
+void h2o_socket_ssl_server_handshake(h2o_socket_t *sock, SSL_CTX *ssl_ctx, h2o_socket_cb handshake_cb)
 {
     static BIO_METHOD bio_methods = {
         BIO_TYPE_FD,
@@ -326,24 +325,13 @@ void h2o_socket_ssl_server_handshake(h2o_socket_t *sock, h2o_ssl_context_t *ssl_
     bio = BIO_new(&bio_methods);
     bio->ptr = sock;
     bio->init = 1;
-    sock->ssl->ssl = SSL_new(ssl_ctx->ctx);
+    sock->ssl->ssl = SSL_new(ssl_ctx);
     SSL_set_bio(sock->ssl->ssl, bio, bio);
 
     sock->ssl->handshake.cb = handshake_cb;
     proceed_handshake(sock, 0);
 }
 
-#if OPENSSL_VERSION_NUMBER >= 0x10002000L
-# define USE_ALPN 1
-# define USE_NPN 1
-#elif OPENSSL_VERSION_NUMBER >= 0x10001000L
-# define USE_ALPN 0
-# define USE_NPN 1
-#else
-# define USE_ALPN 0
-# define USE_NPN 0
-#endif
-
 h2o_buf_t h2o_socket_ssl_get_selected_protocol(h2o_socket_t *sock)
 {
     const unsigned char *data = NULL;
@@ -351,11 +339,11 @@ h2o_buf_t h2o_socket_ssl_get_selected_protocol(h2o_socket_t *sock)
 
     assert(sock->ssl != NULL);
 
-#if USE_ALPN
+#if H2O_USE_ALPN
     if (len == 0)
         SSL_get0_alpn_selected(sock->ssl->ssl, &data, &len);
 #endif
-#if USE_NPN
+#if H2O_USE_NPN
     if (len == 0)
         SSL_get0_next_proto_negotiated(sock->ssl->ssl, &data, &len);
 #endif
@@ -363,10 +351,11 @@ h2o_buf_t h2o_socket_ssl_get_selected_protocol(h2o_socket_t *sock)
     return h2o_buf_init(data, len);
 }
 
-#if USE_ALPN
-static int on_alpn_select(SSL *ssl, const unsigned char **out, unsigned char *outlen, const unsigned char *in, unsigned int inlen, void *_ctx)
+#if H2O_USE_ALPN
+
+static int on_alpn_select(SSL *ssl, const unsigned char **out, unsigned char *outlen, const unsigned char *in, unsigned int inlen, void *_protocols)
 {
-    h2o_ssl_context_t *ctx = _ctx;
+    const h2o_buf_t *protocols = _protocols;
     const unsigned char *in_end = in + inlen;
     size_t i;
 
@@ -376,8 +365,8 @@ static int on_alpn_select(SSL *ssl, const unsigned char **out, unsigned char *ou
             /* broken request */
             break;
         }
-        for (i = 0; ctx->protocols[i].len != 0; ++i) {
-            if (cand_len == ctx->protocols[i].len && memcmp(in, ctx->protocols[i].base, cand_len) == 0) {
+        for (i = 0; protocols[i].len != 0; ++i) {
+            if (cand_len == protocols[i].len && memcmp(in, protocols[i].base, cand_len) == 0) {
                 goto Found;
             }
         }
@@ -387,73 +376,30 @@ static int on_alpn_select(SSL *ssl, const unsigned char **out, unsigned char *ou
     return SSL_TLSEXT_ERR_NOACK;
 
 Found:
-    *out = (const unsigned char*)ctx->protocols[i].base;
-    *outlen = (unsigned char)ctx->protocols[i].len;
+    *out = (const unsigned char*)protocols[i].base;
+    *outlen = (unsigned char)protocols[i].len;
     return SSL_TLSEXT_ERR_OK;
 }
-#endif
 
-#if USE_NPN
-static int on_npn_advertise(SSL *ssl, const unsigned char **out, unsigned *outlen, void *_ctx)
+void h2o_ssl_register_alpn_protocols(SSL_CTX *ctx, const h2o_buf_t *protocols)
 {
-    h2o_ssl_context_t *ctx = _ctx;
+    SSL_CTX_set_alpn_select_cb(ctx, on_alpn_select, (void*)protocols);
+}
 
-    *out = (const unsigned char*)ctx->_npn_list_of_protocols.base;
-    *outlen = (unsigned)ctx->_npn_list_of_protocols.len;
+#endif
+
+#if H2O_USE_NPN
 
+static int on_npn_advertise(SSL *ssl, const unsigned char **out, unsigned *outlen, void *protocols)
+{
+    *out = protocols;
+    *outlen = (unsigned)strlen(protocols);
     return SSL_TLSEXT_ERR_OK;
 }
-#endif
 
-h2o_ssl_context_t *h2o_ssl_new_server_context(const char *cert_file, const char *key_file, const h2o_buf_t *protocols)
+void h2o_ssl_register_npn_protocols(SSL_CTX *ctx, const char *protocols)
 {
-    h2o_ssl_context_t *ctx = h2o_malloc(sizeof(*ctx));
-
-    memset(ctx, 0, sizeof(*ctx));
-
-    SSL_load_error_strings();
-    SSL_library_init();
-    OpenSSL_add_all_algorithms();
-
-    ctx->ctx = SSL_CTX_new(SSLv23_server_method());
-    SSL_CTX_set_options(ctx->ctx, SSL_OP_NO_SSLv2);
-
-    /* load certificate and private key */
-    if (SSL_CTX_use_certificate_file(ctx->ctx, cert_file, SSL_FILETYPE_PEM) != 1) {
-        fprintf(stderr, "an error occured while trying to load server certificate file:%s\n", cert_file);
-        goto Error;
-    }
-    if (SSL_CTX_use_PrivateKey_file(ctx->ctx, key_file, SSL_FILETYPE_PEM) != 1) {
-        fprintf(stderr, "an error occured while trying to load private key file:%s\n", key_file);
-        goto Error;
-    }
+    SSL_CTX_set_next_protos_advertised_cb(ctx, on_npn_advertise, (void*)protocols);
+}
 
-    /* copy list of protocols, init npm */
-    ctx->protocols = protocols;
-    if (protocols != NULL) {
-        size_t i, off;
-#if USE_ALPN
-        SSL_CTX_set_alpn_select_cb(ctx->ctx, on_alpn_select, ctx);
-#endif
-#if USE_NPN
-        SSL_CTX_set_next_protos_advertised_cb(ctx->ctx, on_npn_advertise, ctx);
 #endif
-        for (i = 0; protocols[i].len != 0; ++i) {
-            assert(protocols[i].len <= 255);
-            ctx->_npn_list_of_protocols.len += 1 + protocols[i].len;
-        }
-        ctx->_npn_list_of_protocols.base = h2o_malloc(ctx->_npn_list_of_protocols.len);
-        for (i = 0, off = 0; protocols[i].len != 0; ++i) {
-            ((unsigned char*)ctx->_npn_list_of_protocols.base)[off++] = protocols[i].len;
-            memcpy(ctx->_npn_list_of_protocols.base + off, protocols[i].base, protocols[i].len);
-            off += protocols[i].len;
-        }
-        assert(off == ctx->_npn_list_of_protocols.len);
-    }
-
-    return ctx;
-Error:
-    SSL_CTX_free(ctx->ctx);
-    free(ctx);
-    return NULL;
-}
diff --git a/lib/util.c b/lib/util.c
index b1fcbd8db6..206a040898 100644
--- a/lib/util.c
+++ b/lib/util.c
@@ -451,7 +451,7 @@ static void on_ssl_handshake_complete(h2o_socket_t *sock, int status)
     }
 
     proto = h2o_socket_ssl_get_selected_protocol(sock);
-    for (ident = h2o_http2_tls_identifiers; ident->len != 0; ++ident) {
+    for (ident = h2o_http2_alpn_protocols; ident->len != 0; ++ident) {
         if (proto.len == ident->len && memcmp(proto.base, ident->base, proto.len) == 0) {
             goto Is_Http2;
         }
@@ -465,7 +465,7 @@ static void on_ssl_handshake_complete(h2o_socket_t *sock, int status)
     h2o_http2_accept(ctx, sock);
 }
 
-void h2o_accept_ssl(h2o_context_t *ctx, h2o_socket_t *sock, h2o_ssl_context_t* ssl_ctx)
+void h2o_accept_ssl(h2o_context_t *ctx, h2o_socket_t *sock, SSL_CTX *ssl_ctx)
 {
     sock->data = ctx;
     h2o_socket_ssl_server_handshake(sock, ssl_ctx, on_ssl_handshake_complete);
diff --git a/src/main.c b/src/main.c
index 97d354ad98..6736d554aa 100644
--- a/src/main.c
+++ b/src/main.c
@@ -39,18 +39,25 @@
 # define EX_CONFIG 78
 #endif
 
-struct listener_t {
+struct listener_config_t {
     int fd;
     int family;
     int socktype;
     int protocol;
     struct sockaddr_storage addr;
     socklen_t addrlen;
+    SSL_CTX *ssl_ctx;
+};
+
+struct listener_ctx_t {
+    h2o_context_t *ctx;
+    SSL_CTX *ssl_ctx;
+    h2o_socket_t *sock;
 };
 
 struct config_t {
     h2o_global_configuration_t global_config;
-    struct listener_t **listeners;
+    struct listener_config_t **listeners;
     size_t num_listeners;
     unsigned max_connections;
     unsigned num_threads;
@@ -66,12 +73,79 @@ struct config_t {
     h2o_configurator_t num_threads_configurator;
 };
 
-static h2o_ssl_context_t *ssl_ctx = NULL;
+static void init_openssl(void)
+{
+    static int ready = 0;
+    if (! ready) {
+        SSL_load_error_strings();
+        SSL_library_init();
+        OpenSSL_add_all_algorithms();
+        /* FIXME setup callbacks as said in https://www.openssl.org/docs/crypto/threads.html */
+        ready = 1;
+    }
+}
+
+static SSL_CTX *on_config_listen_setup_ssl(h2o_configurator_t *configurator, const char *config_file, yoml_t *config_node)
+{
+    SSL_CTX *ssl_ctx = NULL;
+    const char *cert_file = NULL, *key_file = NULL;
+    yoml_t *t;
+
+    /* parse */
+    if (config_node->type != YOML_TYPE_MAPPING) {
+        h2o_config_print_error(configurator, config_file, config_node, "`ssl` is not a mapping");
+        goto Error;
+    }
+    if ((t = yoml_get(config_node, "certificate-file")) == NULL) {
+        h2o_config_print_error(configurator, config_file, config_node, "could not find mandatory property `certificate-file`");
+        goto Error;
+    } else if (t->type != YOML_TYPE_SCALAR) {
+        h2o_config_print_error(configurator, config_file, t, "the property must be a string");
+        goto Error;
+    }
+    cert_file = t->data.scalar;
+    if ((t = yoml_get(config_node, "key-file")) == NULL) {
+        h2o_config_print_error(configurator, config_file, config_node, "could not find mandatory property `key-file`");
+        goto Error;
+    } else if (t->type != YOML_TYPE_SCALAR) {
+        h2o_config_print_error(configurator, config_file, t, "the property must be a string");
+        goto Error;
+    }
+    key_file = t->data.scalar;
+
+    /* setup */
+    init_openssl();
+    ssl_ctx = SSL_CTX_new(SSLv23_server_method());
+    SSL_CTX_set_options(ssl_ctx, SSL_OP_NO_SSLv2);
+    if (SSL_CTX_use_certificate_file(ssl_ctx, cert_file, SSL_FILETYPE_PEM) != 1) {
+        h2o_config_print_error(configurator, config_file, config_node, "failed to load certificate file:%s\n", cert_file);
+        goto Error;
+    }
+    if (SSL_CTX_use_PrivateKey_file(ssl_ctx, key_file, SSL_FILETYPE_PEM) != 1) {
+        h2o_config_print_error(configurator, config_file, config_node, "failed to load private key file:%s\n", key_file);
+        goto Error;
+    }
+
+    /* setup protocol negotiation methods */
+#if H2O_USE_NPN
+    h2o_ssl_register_npn_protocols(ssl_ctx, h2o_http2_npn_protocols);
+#endif
+#if H2O_USE_ALPN
+    h2o_ssl_register_alpn_protocols(ssl_ctx, h2o_http2_alpn_protocols);
+#endif
+
+    return ssl_ctx;
+Error:
+    if (ssl_ctx != NULL)
+        SSL_CTX_free(ssl_ctx);
+    return NULL;
+}
 
 static int on_config_listen(h2o_configurator_t *configurator, void *ctx, const char *config_file, yoml_t *config_node)
 {
     struct config_t *conf = H2O_STRUCT_FROM_MEMBER(struct config_t, port_configurator, configurator);
     const char *hostname = NULL, *servname = NULL;
+    SSL_CTX *ssl_ctx = NULL;
     struct addrinfo hints, *res;
     int error;
 
@@ -99,6 +173,10 @@ static int on_config_listen(h2o_configurator_t *configurator, void *ctx, const c
                 return -1;
             }
             servname = t->data.scalar;
+            if ((t = yoml_get(config_node, "ssl")) != NULL) {
+                if ((ssl_ctx = on_config_listen_setup_ssl(configurator, config_file, t)) == NULL)
+                    return -1;
+            }
         }
         break;
     default:
@@ -122,13 +200,14 @@ static int on_config_listen(h2o_configurator_t *configurator, void *ctx, const c
     { /* save the entries */
         struct addrinfo *ai;
         for (ai = res; ai != NULL; ai = ai->ai_next) {
-            struct listener_t *listener = h2o_malloc(sizeof(*listener));
+            struct listener_config_t *listener = h2o_malloc(sizeof(*listener));
             listener->fd = -1;
             listener->family = ai->ai_family;
             listener->socktype = ai->ai_socktype;
             listener->protocol = ai->ai_protocol;
             memcpy(&listener->addr, ai->ai_addr, ai->ai_addrlen);
             listener->addrlen = ai->ai_addrlen;
+            listener->ssl_ctx = ssl_ctx;
             conf->listeners = h2o_realloc(conf->listeners, sizeof(*conf->listeners) * (conf->num_listeners + 1));
             conf->listeners[conf->num_listeners++] = listener;
         }
@@ -155,7 +234,7 @@ static int on_config_listen_complete(h2o_configurator_t *_conf, void *_global_co
     }
 
     for (i = 0; i != conf->num_listeners; ++i) {
-        struct listener_t *listener = conf->listeners[i];
+        struct listener_config_t *listener = conf->listeners[i];
         if ((listener->fd = socket(listener->family, listener->socktype, listener->protocol)) == -1
             || setsockopt(listener->fd, SOL_SOCKET, SO_REUSEADDR, &reuseaddr_flag, sizeof(reuseaddr_flag)) != 0
 #ifdef IPV6_V6ONLY
@@ -293,8 +372,8 @@ static void on_close(h2o_context_t *ctx)
 
 static void on_accept(h2o_socket_t *listener, int status)
 {
-    h2o_context_t *ctx = listener->data;
-    struct config_t *conf = H2O_STRUCT_FROM_MEMBER(struct config_t, global_config, ctx->global_config);
+    struct listener_ctx_t *ctx = listener->data;
+    struct config_t *conf = H2O_STRUCT_FROM_MEMBER(struct config_t, global_config, ctx->ctx->global_config);
     int num_accepts = 16;
 
     if (status == -1) {
@@ -310,10 +389,10 @@ static void on_accept(h2o_socket_t *listener, int status)
         }
         __sync_add_and_fetch(&conf->state.num_connections, 1);
 
-        if (ssl_ctx != NULL)
-            h2o_accept_ssl(ctx, sock, ssl_ctx);
+        if (ctx->ssl_ctx != NULL)
+            h2o_accept_ssl(ctx->ctx, sock, ctx->ssl_ctx);
         else
-            h2o_http1_accept(ctx, sock);
+            h2o_http1_accept(ctx->ctx, sock);
 
     } while (--num_accepts != 0);
 }
@@ -324,21 +403,22 @@ static void *run_loop(void *_conf)
     struct config_t *conf = _conf;
     h2o_evloop_t *loop;
     h2o_context_t ctx;
-    h2o_socket_t **listeners = alloca(sizeof(*listeners) * conf->num_listeners);
+    struct listener_ctx_t *listeners = alloca(sizeof(*listeners) * conf->num_listeners);
     size_t i;
 
     /* setup loop and context */
     loop = h2o_evloop_create();
     h2o_context_init(&ctx, loop, &conf->global_config);
-    /* ssl_ctx = h2o_ssl_new_server_context("server.crt", "server.key", h2o_http2_tls_identifiers); */
 
     /* setup listeners */
     for (i = 0; i != conf->num_listeners; ++i) {
-        listeners[i] = h2o_evloop_socket_create(
+        listeners[i].ctx = &ctx;
+        listeners[i].ssl_ctx = conf->listeners[i]->ssl_ctx;
+        listeners[i].sock = h2o_evloop_socket_create(
             ctx.loop, conf->listeners[i]->fd,
             (struct sockaddr*)&conf->listeners[i]->addr, conf->listeners[i]->addrlen,
             H2O_SOCKET_FLAG_IS_ACCEPT);
-        listeners[i]->data = &ctx;
+        listeners[i].sock->data = listeners + i;
     }
 
     /* the main loop */
@@ -346,13 +426,13 @@ static void *run_loop(void *_conf)
         /* start / stop trying to accept new connections */
         if (conf->state.num_connections < conf->max_connections) {
             for (i = 0; i != conf->num_listeners; ++i) {
-                if (! h2o_socket_is_reading(listeners[i]))
-                    h2o_socket_read_start(listeners[i], on_accept);
+                if (! h2o_socket_is_reading(listeners[i].sock))
+                    h2o_socket_read_start(listeners[i].sock, on_accept);
             }
         } else {
             for (i = 0; i != conf->num_listeners; ++i) {
-                if (h2o_socket_is_reading(listeners[i]))
-                    h2o_socket_read_stop(listeners[i]);
+                if (h2o_socket_is_reading(listeners[i].sock))
+                    h2o_socket_read_stop(listeners[i].sock);
             }
         }
         /* run the loop once */
@@ -374,9 +454,12 @@ int main(int argc, char **argv)
         "port at which the server should listen for incoming requests (mandatory)",
         " - if the value is a scalar, it is treated as the port number (or as the",
         "   service name)",
-        " - if the value is a mapping, its `port` property is treated as the port",
-        "   number (or as the service name), and optionally its `host` property is",
-        "   treated as the incoming address (or as the hostname)\n",
+        " - if the value is a mapping, following properties are recognized:",
+        "     port: incoming port number or service name (mandatory)",
+        "     host: incoming address (default: any address)",
+        "     ssl:  if using SSL (default: none)",
+        "       certificate-file: path of the certificate file",
+        "       key-file:         path of the key file",
         NULL
     };
     static const char *num_threads_configurator_desc[] = {
